//This file is part of AcetoneISO. Copyright 2006,2007,2008,2009 Fabrizio Di Marco and Marco Di Antonio  (acetoneiso@gmail.com)
//
//    AcetoneISO is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    AcetoneISO is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with AcetoneISO.  If not, see <http://www.gnu.org/licenses/>.

#include <QtGui>
#include <QTabWidget>
#include <QWebView>
#include "acetoneiso.h"
#include <fcntl.h>
#include <iostream>
#include <QProcess>
#include <QUrl>
#include <QProgressBar>
#include <QDirIterator>
#include <QSystemTrayIcon>
#include"status_mounted_no_boot.h"
#include"md5check.h"
#include"mount.h"
#include"encrypt.h"
#include"foldertoiso.h"
#include"donate.h"
#include"psxrip.h"
#include"compress.h"
#include"converter.h"
#include"isocd.h"
#include"split.h"
#include"play.h"
#include"gencue.h"
#include"database.h"
#include"gmount.h"
#include"eltorito.h"
#include"backup_audio.h"
#include"messages.h"
#include"status_mounted.h"
#include"options.h"
#include"about.h"
#include"progress.h"
#include"manual.h"
#include"udf.h"
#include"vidgen.h"
#include"utube.h"
#include"audiotools.h"
#include"umount_check.h"
#include"iso_from_pcgame.h"
#include"leggirigo.h"
#include"psp.h"
#include"history.h"
#include"global_functions.h"

acetoneiso::acetoneiso()
{
QPixmap splashpng(":/images/splash.png");
QSplashScreen *splash = new QSplashScreen(splashpng);
splash->show();
splash->showMessage(tr("Loading GUI..."));


  QDir Temp = QDir::temp();
  Temp.mkdir("acetoneiso");
  //Temp.mkdir("acetoneiso_burn");

  QDir Home = QDir::home();
  Home.mkdir("virtual-drives");
  Home.cd("virtual-drives");
  Home.mkdir("1");
  Home.mkdir("2");
  Home.mkdir("3");
  Home.mkdir("4");
  Home.mkdir("5");
  Home.mkdir("6");
  Home.mkdir("7");
  Home.mkdir("dvd");
  Home.mkdir("../.acetoneiso");
  Home.cd(".acetoneiso");



    setupUi(this); // this sets up GUI
    setDockInit();
    status_mounted(); //questa funzione va prima del montaggio da cml altrimenti ho una doppia entry nel montaggio da terminale
    cmlMount();


    connect( actionConvert_MacOs_Image_2, SIGNAL ( triggered() ), this, SLOT ( macimg() ) );
    connect( pushButton, SIGNAL( clicked() ), this, SLOT( mount() ) ); 
    connect( pushButton_2, SIGNAL( clicked() ), this, SLOT( umount() ) ); 
    
    connect( pushButton_3, SIGNAL( clicked() ), this, SLOT( clear_history() ) ); 
    connect( pushButton_6, SIGNAL( clicked() ), this, SLOT( hide_process_display() ) ); 
    
    connect(actionMake_a_small_donation, SIGNAL( triggered() ), this, SLOT( paypal() ) );
    connect( pushButton_4, SIGNAL( triggered() ), this, SLOT( extract() ) ); 
    connect( actionMount_Image, SIGNAL( triggered() ), this, SLOT( mount() ) );
    connect( actionDonate, SIGNAL( triggered() ), this, SLOT( a_donate() ) );
    connect( actionExit, SIGNAL( triggered() ), qApp, SLOT( quit() ) );
    connect( pushButton_Omni_3, SIGNAL( triggered() ), this, SLOT( converter() ) );
    connect( pushButton_IsoFromFolder_2, SIGNAL( triggered() ), this, SLOT( foldertoiso() ) );
    connect( actionA_protected_CD_DVD, SIGNAL( triggered() ), this, SLOT( isopcgame() ) );
    connect( pushButton_PSX_Rip, SIGNAL( triggered() ), this, SLOT( psxrip() ) );
    connect( button_backup_audio_2, SIGNAL( triggered() ), this, SLOT( backupaudio() ) );
    connect( actionCompress, SIGNAL( triggered() ), this, SLOT( compress() ) ); 
    connect( actionDecrypt, SIGNAL( triggered() ), this, SLOT( decrypt() ) );
    connect( actionEncrypt, SIGNAL( triggered() ), this, SLOT( encrypt() ) );
    connect( pushButton_IsoFromFolder_3, SIGNAL( triggered() ), this, SLOT( isocd() ) );
    connect( actionMerge_Splitted_Image, SIGNAL( triggered() ), this, SLOT( merge() ) );
    connect( actionSplit, SIGNAL( triggered() ), this, SLOT( split() ) );
    connect( actionExtract, SIGNAL( triggered() ), this, SLOT( uncompress() ) );
    connect( actionPlay, SIGNAL( triggered() ), this, SLOT( play() ) );
    connect( actionUmount_2, SIGNAL( triggered() ), this, SLOT( unplay() ) );
    connect( pushButton_GenCUE, SIGNAL( triggered() ), this, SLOT( gencue() ) );
    connect( actionMount_UDF_ISO_2, SIGNAL( triggered() ), this, SLOT( udf() ) );

    connect( actionConvert_video_for_PSP, SIGNAL( triggered() ), this, SLOT( convertpsp() ) );
    
connect( pushButton_5, SIGNAL( clicked() ), this, SLOT( call_database_options() ) );

    connect( actionRip_DVD_2_Xvid, SIGNAL( triggered() ), this, SLOT( rip() ) );
    connect( actionConvert_generic_video, SIGNAL( triggered() ), this, SLOT( vidgeneric() ) );
    connect( actionWithout_Account, SIGNAL( triggered() ), this, SLOT( utube() ) );
    connect( actionUser_Account_Login, SIGNAL( triggered() ), this, SLOT( utubeuser() ) );
    connect(actionUnmount_Image,SIGNAL( triggered() ), this, SLOT( umount() ) );
    //connect( actionPornTube_Download_Video, SIGNAL( triggered() ), this, SLOT( pornotube() ) );
    connect( actionMetaCafe_Download_Video, SIGNAL( triggered() ), this, SLOT( metacafe() ) );
    connect( actionConvert_FLV_2_AVI, SIGNAL( triggered() ), this, SLOT( flvavi() ) );
    connect( actionConvert_WMA_2_MP3, SIGNAL( triggered() ), this, SLOT( wma2wav() ) );
    connect( actionExtract_a_RAR_password_protectd, SIGNAL( triggered() ), this, SLOT( rar() ) );
    connect( actionGenerate_Md5, SIGNAL( triggered() ), this, SLOT( md5generate() ) );
    connect( actionCheck_Md5, SIGNAL( triggered() ), this, SLOT( md5check() ) );
    connect( actionGeneric_Mount_2, SIGNAL( triggered() ), this, SLOT( gmount() ) );
    connect( actionGeneric_Umount_2, SIGNAL( triggered() ), this, SLOT( gumount() ) );
  
    connect( actionExtract_Boot_Image_2, SIGNAL( triggered() ), this, SLOT( getboot() ) );
    //connect( &MKisofs, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
   // connect( &MKisofs, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOut(int, QProcess::ExitStatus)));
    //connect( &MKisofs, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( initial_get_database() ));
    connect( &GPg, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &GPg, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutgpg(int, QProcess::ExitStatus)));
    connect( &PZip, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &PZip, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutcompress(int, QProcess::ExitStatus)));
    connect( &SPlit, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &SPlit, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutsplit(int, QProcess::ExitStatus)));
    connect( &PZipuncompress, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &PZipuncompress, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutuncompress(int, QProcess::ExitStatus)));
    connect( listWidget, SIGNAL( itemDoubleClicked (QListWidgetItem *) ), this, SLOT(mdatabase(QListWidgetItem *) ) );
    connect( &DD, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &DD, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutisofromcd(int, QProcess::ExitStatus)));
    connect( &DD, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( initial_get_database() ));
    connect( listWidget_2, SIGNAL( itemDoubleClicked (QListWidgetItem *) ), this, SLOT(open_mounted(QListWidgetItem *) ) );
    connect( &TAr, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &TAr, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(messaggio_poweriso()));
   // connect( &POweriso, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
   
    connect( &CUe, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &CUe, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutcue(int, QProcess::ExitStatus)));
    connect( pushButton_delImage, SIGNAL( clicked() ), this, SLOT( remove_fromDatabase() ) );
    connect( pushButton_updateDB, SIGNAL( clicked() ), this, SLOT( initial_get_database() ) );
    connect( &WGet2, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &CAt, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &CAt, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( mergeMSG(int, QProcess::ExitStatus) ) );
    connect( &FUse, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutfuseiso(int, QProcess::ExitStatus)));
    connect( &ELtorito, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &TOc, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));

    
    connect( &AUdio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &AUdio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutaudiotools(int, QProcess::ExitStatus)));
    connect( &FUsermount, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &FUsermount, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutumount(int, QProcess::ExitStatus)));
    connect( &BIso, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &UCheck, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutucheck(int, QProcess::ExitStatus)));
    connect( actionRip_CD_Audio_to_WAV, SIGNAL( triggered() ), this, SLOT( ripcdaudio() ) );
    connect( &RIpaudio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &RIpaudio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutripaudio(int, QProcess::ExitStatus)));
    connect( &AUdio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutripaudio(int, QProcess::ExitStatus)));
    connect( actionExtract_Audio_from_any_Video_file, SIGNAL( triggered() ), this, SLOT( extractaudio() ) );

    connect( lineEdit, SIGNAL( editingFinished() ), this, SLOT( search() ) );
    connect( lineEdit, SIGNAL( cursorPositionChanged ( int , int ) ), this, SLOT( search() ) );
    connect(dockWidget1, SIGNAL(dockLocationChanged(Qt::DockWidgetArea)),this, SLOT(setDockPos()));
    connect(listWidget, SIGNAL(customContextMenuRequested(const QPoint &)), this, SLOT(userListMenuRequested(const QPoint &))); 
    connect(history, SIGNAL(customContextMenuRequested(const QPoint &)), this, SLOT(historycontextmenu(const QPoint &))); 
    connect( history, SIGNAL( itemDoubleClicked (QListWidgetItem *) ), this, SLOT(historydoubleclickmount(QListWidgetItem *) ) );
    connect( search_history_lineedit, SIGNAL( editingFinished() ), this, SLOT( search_history() ) );
    connect( search_history_lineedit, SIGNAL( cursorPositionChanged ( int , int ) ), this, SLOT( search_history() ) );
    connect(listWidget_2, SIGNAL(customContextMenuRequested(const QPoint &)), this, SLOT(mountdisplaycontextmenu(const QPoint &))); 
    


listWidget_2->setAcceptDrops(true);
//progress1Bar->setVisible( false );
splash->showMessage(tr("Loading Options..."));
createOption();
initial_get_database();
history_autoclean();
load_history();



    AboutAction = new QAction(tr("About AcetoneISO"), this);
    connect(AboutAction, SIGNAL(triggered()), this, SLOT(on_actionAbout_activated() ));
    OptionsAction = new QAction(tr("Options"), this);
    connect(OptionsAction, SIGNAL(triggered()), this, SLOT(on_options_nda_activated() ));
    
    MountAction = new QAction(tr("Mount Image"), this);
    connect(MountAction, SIGNAL(triggered()), this, SLOT(mount()));
    restoreAction = new QAction(tr("&Restore"), this);
    connect(restoreAction, SIGNAL(triggered()), this, SLOT(showNormal()));
    quitAction = new QAction(tr("&Quit"), this);
    connect(quitAction, SIGNAL(triggered()), qApp, SLOT(quit()));
    
    QIcon about_icon( ":/images/Acetino2.png" );
    QIcon options_icon( ":/images/aoptions.png" );
    QIcon mount_icon( ":/images/cdwriter_mount.png" );
    QIcon restore_icon( ":/images/file_manager.png" );
    QIcon exit_icon( ":/images/application-exit.png" ); 
    quitAction->setIcon(exit_icon);
    restoreAction->setIcon(restore_icon);
    MountAction->setIcon(mount_icon);
    AboutAction->setIcon(about_icon);
    OptionsAction->setIcon(options_icon);



tray_has_loaded = false;   
//load tray icon
QDir HomeT = QDir::home();
QFile fileT(HomeT.path() + "/.acetoneiso/acetoneiso_advanced.conf");
fileT.open(QIODevice::ReadOnly | QIODevice::Text);
QString tray = fileT.readAll();
  if(tray.contains("enabletrayicon", Qt::CaseInsensitive)) {
    trayIcon = new QSystemTrayIcon();
    QIcon icon = QIcon(":/images/Acetino2.png");
    trayIcon->setIcon(icon);
    trayIcon->show();
    trayIcon->setToolTip(tr("AcetoneISO I love You!"));
    
    trayIconMenu = new QMenu(this);
    
    trayIconMenu->addAction(AboutAction);
    trayIconMenu->addAction(OptionsAction);
    trayIconMenu->addSeparator();
    trayIconMenu->addAction(MountAction);
    trayIconMenu->addSeparator();
    trayIconMenu->addAction(restoreAction);
    trayIconMenu->addAction(quitAction);
    trayIcon->setContextMenu(trayIconMenu);    
    tray_has_loaded = true;
connect(trayIcon, SIGNAL(activated(QSystemTrayIcon::ActivationReason)), this, SLOT(iconActivated(QSystemTrayIcon::ActivationReason)));
  }
  
//database label
database_label();

//hide process display and its contents 
hide_process_display();

splash->finish(this);
}


//cattura segnale di chiusura per mandarlo in tray
void acetoneiso::closeEvent(QCloseEvent *event)
{
QDir HomeT = QDir::home();
QFile fileT(HomeT.path() + "/.acetoneiso/acetoneiso_advanced.conf");
fileT.open(QIODevice::ReadOnly | QIODevice::Text);
QString tray = fileT.readAll();

  if(!tray.contains("enabletrayicon", Qt::CaseInsensitive)) {
    return;
  }

//evita segfault se l'utente abilita la tray icon con close in tray icon abilitato senza ancora aver riavviato per attivare la tray
if (tray_has_loaded == false) {
 return; 
}


  if(tray.contains("noclosetrayt", Qt::CaseInsensitive)) {
        if (trayIcon->isVisible()) {
        hide();
        event->ignore();
	}
  }
fileT.close();
}


//gestisce l'oscuramento nel context menu della tray icon
void acetoneiso::setVisible(bool visible)
{
  
QDir HomeT = QDir::home();
QFile fileT(HomeT.path() + "/.acetoneiso/acetoneiso_advanced.conf");
fileT.open(QIODevice::ReadOnly | QIODevice::Text);
QString tray = fileT.readAll();
  if(tray.contains("enabletrayicon", Qt::CaseInsensitive)) {
   // minimizeAction->setEnabled(visible);
   
   restoreAction->setEnabled(true);
    QMainWindow::setVisible(visible);
  }
  else {
   QMainWindow::setVisible(visible); 
  }
fileT.close();
}
//gestisce cosa fare quando l'utente clicca con il sinistro sulla tray icon
void acetoneiso::iconActivated(QSystemTrayIcon::ActivationReason reason)
{
    switch (reason) {
    case QSystemTrayIcon::Trigger:
    case QSystemTrayIcon::DoubleClick:
     
     if (QMainWindow::isMinimized()) {
	QMainWindow::showNormal();   
	return;
      }
     if (QMainWindow::isHidden()) {
        QMainWindow::setVisible(true);  
	QMainWindow::showNormal();   
	return;
      }
      else {
	QMainWindow::hide(); 
	return;
      }

        break;
    case QSystemTrayIcon::MiddleClick:
      
      if (QMainWindow::isMinimized()) {
	QMainWindow::showNormal();   
	return;
      }
     if (QMainWindow::isHidden()) {
        QMainWindow::setVisible(true);  
	QMainWindow::showNormal();   
	return;
      }
      else {
	QMainWindow::hide(); 
	return;
      }
      
        break;
    default:
        ;
    }
}



void acetoneiso::progBarra()
{
      prog.show();
}

void acetoneiso::closeProg()
{
prog.close();
}

void acetoneiso::on_options_nda_activated()
{
QMainWindow::showNormal();
optionsDiag *opt=new optionsDiag;
opt->exec();
}


//gestire che lutente vuole aprire lopzioni direttamente in database
void acetoneiso::call_database_options() {
    QDir Home = QDir::home();
    QFile advanced(Home.path() + "/.acetoneiso/optiondb.conf");
    advanced.remove();
      advanced.open(QIODevice::WriteOnly | QIODevice::Text);
      QTextStream out_adv(&advanced);
      out_adv << ( "must call option directly in database settings\n" );
      advanced.close();
on_options_nda_activated();  
}





void acetoneiso::createOption()
{  
  
    QDir Home = QDir::home();
    QFile advanced(Home.path() + "/.acetoneiso/acetoneiso_advanced.conf");
    if (!advanced.exists()) {
      advanced.open(QIODevice::WriteOnly | QIODevice::Text);
      QTextStream out_adv(&advanced);
      out_adv << ( "TRAYICON = enabletrayicon\n" );
      out_adv << ( "TRAYICON_CLOSE = closetrayicon\n" );
      out_adv << ( "HISTORY_CLEAN = cleanhistory\n" );
      out_adv << ( "HISTORY_REMOVE_FAKE = removefakehistory\n" );
      advanced.close();  
 }


QFile file(Home.path() + "/.acetoneiso/acetoneiso.conf");
if( !file.exists() ) {
   file.open(QIODevice::WriteOnly | QIODevice::Text);
   QTextStream out(&file);
   out << ( "ISO_FROM_FOLDER = standard\n" );
   out << ( "PLAYER = kaffeine\n" );
   out << ( "FILE_BROWSER = kde\n" );
   out << ( "DB = " + Home.path() + "\n" );
   out << ( "recursive = norecursive" "\n" );
   file.close();
 advanced.remove();
QMessageBox::warning(this, "AcetoneISO::First Launch",tr("This is the first time you launch AcetoneISO software.\nIn the next dialog you can set your default file manager, set database and some other things.\nHappy AcetoneISO usage from the team:)"));
on_options_nda_activated();
   }

}


void acetoneiso::on_actionAbout_activated()
{
QMainWindow::showNormal();
aboutDiag *abt=new aboutDiag;
abt->exec();
}

void acetoneiso::on_actionManual_activated()
{
manualDiag *man=new manualDiag;
man->exec();
}


void acetoneiso::setDockPos()
{
QDir Home = QDir::home();
QFile windowStateFile(Home.path() + "/.acetoneiso/gui.state");
    QByteArray state = saveState();

    if(windowStateFile.open(QIODevice::WriteOnly))
    {
      windowStateFile.write(state);
      windowStateFile.close();
    }
}

void acetoneiso::setDockInit()
{
QDir Home = QDir::home();
QFile windowStateFile(Home.path() + "/.acetoneiso/gui.state");
    if(windowStateFile.open(QIODevice::ReadOnly))
    {
      QByteArray bytes = windowStateFile.readAll();
      restoreState(bytes);
      windowStateFile.close();
    }
}







